<?php
/**
 * Plugin Name: CurrentStatus
 * Plugin URI: http://itgeek.in/?post_id=180
 * Version: v1.0
 * Author: <a href="http://www.itgeek.in/">Charandeep Singh</a>
 * Author URI: http://itgeek.in
 * Description: This Plugin is used to display your current status and mood from the list of 155 different moods.
 */

/**
 * Globals 
 */
register_activation_hook(__FILE__, 'CurrentStatus_Init');
add_action('admin_menu', 'CurrentStatus_Admin');

/**
 * initial setup, this function will run on the activation of the plugin
 *
 * @return TRUE
 */
function CurrentStatus_Init() {
	add_option('CurrentStatus_Status', 'Just installed CurrentStatus Plugin');
	add_option('CurrentStatus_Mood', 'Excited');
	add_option('CurrentStatus_Structure', '<b>Status: </b>%STATUS%<br /><b>Mood: </b>%MOOD%');
	return TRUE;
}


/**
 * admin settings
 *
 */
function CurrentStatus_Admin() {
  add_options_page('CurrentStatus Plugin Options', 'CurrentStatus', 8, __FILE__, 'CurrentStatus_Options');
}

/**
 * admin panel options
 *
 */
function CurrentStatus_Options() {
	$CurrentStatus_moodslist = array('None', 'Afraid', 'Amazed', 'Angry', 'Annoyed', 'Anxious', 'Aroused', 'Ashamed', 'Accomplished', 'Aggravated', 'Alone', 'Amused', 'Apathetic', 'Awake', 'Accepted', 'Bored', 'Brave', 'Bewildered', 'Bitchy', 'Bittersweet', 'Blah', 'Blank', 'Blissful', 'Bouncy', 'Calm', 'Cold', 'Confused', 'Contented', 'Curious', 'Cheerful', 'Chipper', 'Complacent', 'Content', 'Cranky', 'Crappy', 'Crazy', 'Crushed', 'Cynical', 'Depressed', 'Disappointed', 'Disgusted', 'Distracted', 'Dark', 'Determined', 'Devious', 'Dirty', 'Discontent', 'Ditzy', 'Dorky', 'Drained', 'Drunk', 'Embarrassed', 'Excited', 'Ecstatic', 'Energetic', 'Enraged', 'Enthralled', 'Envious', 'Exanimate', 'Exhausted', 'Flirtations', 'Frustrated', 'Flirty', 'Full', 'Grumpy', 'Guilty', 'Geeky', 'Giddy', 'Giggly', 'Gloomy', 'Good', 'Grateful', 'Groggy', 'Grumpy', 'Guilty', 'Happy', 'Hot', 'Humbled', 'Humiliated', 'Hungry', 'Hurt', 'High', 'Hopeful', 'Hyper', 'Impressed', 'In awe', 'In love', 'Indignant', 'Interested', 'Intoxicated', 'Invincible', 'Indescribable', 'Indifferent', 'Infuriated', 'Irate',  'Jealous', 'Jubilant', 'Lonely', 'Lazy', 'Lethargic', 'Listless', 'Loved', 'Mean', 'Moody', 'Mad', 'Melancholy', 'Mellow', 'Mischievous', 'Moody', 'Morose', 'Nervous', 'Neutral', 'Naughty', 'Nerdy', 'Not Specified', 'Numb', 'Offended', 'Optimistic', 'Playful', 'Proud', 'Peaceful', 'Pessimistic', 'Pissed off', 'Pleased', 'Predatory', 'Quixotic', 'Relieved', 'Remorseful', 'Restless', 'Recumbent', 'Refreshed', 'Rejected', 'Rejuvenated', 'Relaxed', 'Relieved', 'Rushed', 'Sad', 'Sarcastic', 'Serious', 'Shocked', 'Shy', 'Sick', 'Sleepy', 'Stressed', 'Surprised', 'Satisfied', 'Silly', 'Smart', 'Thristy', 'Thankful', 'Tired', 'Touched', 'Uncomfortable', 'Weird', 'Worried');
	
	if($_POST['update'] == 'TRUE' ) {
		update_option('CurrentStatus_Status', $_POST['CurrentStatus_Status']);
		update_option('CurrentStatus_Mood', $_POST['CurrentStatus_Mood']);
        update_option('CurrentStatus_Structure', $_POST['CurrentStatus_Structure']);
		
?>
		<div class="updated">
		 <p><strong>Status Updated!</strong></p>
		</div>
<?php
	}
?>
	<div class="wrap">
	 <h2>CurrentStatus Plugin By <a href="http://www.itgeek.in">Charandeep Singh</a></h2>
	 <p>Welcome to CurrentStatus Plugin, change your current status or mood by simply fill status in the text field or select mood from the dropdown list of moods, then click "Update".</p>
	 <form name="form1" method="post" action="<?php _e(str_replace('%7E', '~', $_SERVER['REQUEST_URI'])); ?>">
	  <input type="hidden" name="update" value="TRUE">
	   <table>
	    <tr><td><p>
	     Status: <input type="text" name="CurrentStatus_Status" value="<?php _e(get_option('CurrentStatus_Status')) ?>" size="40">
	    </p></td></tr>
		
	    <tr><td><p>
		 Mood: 
		 <select name="CurrentStatus_Mood">
<?php
		  foreach ($CurrentStatus_moodslist as $value) {
			if($value == get_option('CurrentStatus_Mood'))
				_e('<option SELECTED>');
			else
				_e('<option>');
			_e($value . '</option>');
		  }
?>
		 </select>
		</p></td></tr>
		
		<tr><td>
	     <p>Structure:</p>
		 <p><textarea name="CurrentStatus_Structure" rows="10" cols="40"><?php _e(str_replace('\\', '' , get_option('CurrentStatus_Structure'))) ?></textarea></p>
		</td></tr>

		<tr><td>
		 <p class="submit">
		  <input type="submit" name="Submit" value="Update" />
		 </p>
		</td></tr>
	   </table>
	  </form>
	 </div>
<?php
}

/**
 * admin panel options
 *
 * @return status text
 */
function CurrentStatus_GetStatus() {
	return get_option('CurrentStatus_Status');
}

/**
 * admin panel options
 *
 * @return mood text
 */
function CurrentStatus_GetMood() {
	return get_option('CurrentStatus_Mood');
}

/**
 * admin panel options
 *
 * @return formatted status and mood
 */
function CurrentStatus_GetCurrentStatus() {
	$structure = get_option('CurrentStatus_Structure');
	$replace = array('%STATUS%', '%MOOD%', '\\');
	$with = array(get_option('CurrentStatus_Status'), get_option('CurrentStatus_Mood'), '');
	
	return str_replace($replace, $with, $structure);
}

?>